<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInterfacePersonResult_V5 ArrayType
 * @subpackage Arrays
 */
class ArrayOfInterfacePersonResult_V5 extends AbstractStructArrayBase
{
    /**
     * The InterfacePersonResult_V5
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InterfacePersonResult_V5[]
     */
    public $InterfacePersonResult_V5;
    /**
     * Constructor method for ArrayOfInterfacePersonResult_V5
     * @uses ArrayOfInterfacePersonResult_V5::setInterfacePersonResult_V5()
     * @param \StructType\InterfacePersonResult_V5[] $interfacePersonResult_V5
     */
    public function __construct(array $interfacePersonResult_V5 = array())
    {
        $this
            ->setInterfacePersonResult_V5($interfacePersonResult_V5);
    }
    /**
     * Get InterfacePersonResult_V5 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InterfacePersonResult_V5[]|null
     */
    public function getInterfacePersonResult_V5()
    {
        return isset($this->InterfacePersonResult_V5) ? $this->InterfacePersonResult_V5 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInterfacePersonResult_V5 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInterfacePersonResult_V5 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInterfacePersonResult_V5ForArrayConstraintsFromSetInterfacePersonResult_V5(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfInterfacePersonResult_V5InterfacePersonResult_V5Item) {
            // validation for constraint: itemType
            if (!$arrayOfInterfacePersonResult_V5InterfacePersonResult_V5Item instanceof \StructType\InterfacePersonResult_V5) {
                $invalidValues[] = is_object($arrayOfInterfacePersonResult_V5InterfacePersonResult_V5Item) ? get_class($arrayOfInterfacePersonResult_V5InterfacePersonResult_V5Item) : sprintf('%s(%s)', gettype($arrayOfInterfacePersonResult_V5InterfacePersonResult_V5Item), var_export($arrayOfInterfacePersonResult_V5InterfacePersonResult_V5Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InterfacePersonResult_V5 property can only contain items of type \StructType\InterfacePersonResult_V5, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InterfacePersonResult_V5 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InterfacePersonResult_V5[] $interfacePersonResult_V5
     * @return \ArrayType\ArrayOfInterfacePersonResult_V5
     */
    public function setInterfacePersonResult_V5(array $interfacePersonResult_V5 = array())
    {
        // validation for constraint: array
        if ('' !== ($interfacePersonResult_V5ArrayErrorMessage = self::validateInterfacePersonResult_V5ForArrayConstraintsFromSetInterfacePersonResult_V5($interfacePersonResult_V5))) {
            throw new \InvalidArgumentException($interfacePersonResult_V5ArrayErrorMessage, __LINE__);
        }
        if (is_null($interfacePersonResult_V5) || (is_array($interfacePersonResult_V5) && empty($interfacePersonResult_V5))) {
            unset($this->InterfacePersonResult_V5);
        } else {
            $this->InterfacePersonResult_V5 = $interfacePersonResult_V5;
        }
        return $this;
    }
    /**
     * Add item to InterfacePersonResult_V5 value
     * @throws \InvalidArgumentException
     * @param \StructType\InterfacePersonResult_V5 $item
     * @return \ArrayType\ArrayOfInterfacePersonResult_V5
     */
    public function addToInterfacePersonResult_V5(\StructType\InterfacePersonResult_V5 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InterfacePersonResult_V5) {
            throw new \InvalidArgumentException(sprintf('The InterfacePersonResult_V5 property can only contain items of type \StructType\InterfacePersonResult_V5, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InterfacePersonResult_V5[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\InterfacePersonResult_V5|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\InterfacePersonResult_V5|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\InterfacePersonResult_V5|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\InterfacePersonResult_V5|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\InterfacePersonResult_V5|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InterfacePersonResult_V5
     */
    public function getAttributeName()
    {
        return 'InterfacePersonResult_V5';
    }
}
